package com.dcsoft.system.api.factory;

import com.dcsoft.common.core.web.domain.AjaxResult;
import com.dcsoft.system.api.domain.SmsDTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;
import com.dcsoft.common.core.domain.R;
import com.dcsoft.system.api.RemoteUserService;
import com.dcsoft.system.api.domain.SysUser;
import com.dcsoft.system.api.model.LoginUser;

/**
 * 用户服务降级处理
 *
 * @author dcsoft
 */
@Component
public class RemoteUserFallbackFactory implements FallbackFactory<RemoteUserService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteUserService create(Throwable throwable)
    {
        log.error("用户服务调用失败:{}", throwable.getMessage());
        return new RemoteUserService()
        {
            @Override
            public R<LoginUser> getUserInfo(String username, String source)
            {
                return R.fail("获取用户失败:" + throwable.getMessage());
            }

            @Override
            public R<LoginUser> getUserInfos(String username, String source) {
                return null;
            }

            @Override
            public R<Boolean> registerUserInfo(SysUser sysUser, String source)
            {
                return R.fail("注册用户失败:" + throwable.getMessage());
            }

            @Override
            public R<LoginUser> getWxUserInfo(String openid, String source)
            {
                return R.fail("获取用户失败:" + throwable.getMessage());
            }
            @Override
            public R<Boolean> updateOpenId(SysUser sysUser, String source)
            {
                return R.fail("绑定用户openid失败:" + throwable.getMessage());
            }

            @Override
            public R<?> updateByUserId(SysUser sysUser, String source) {
                return R.fail("更新用户信息失败:" + throwable.getMessage());
            }

            @Override
            public AjaxResult insertVisitor(SysUser sysUser, String source) {
                return null;
            }

            @Override
            public AjaxResult sendMessage(SmsDTO smsDTO, String source) {
                return null;
            }

            @Override
            public AjaxResult selectConfigByKey(String configKey) {
                return null;
            }

        };
    }
}
